﻿#region using
using System;
using BlogEngine.Core.Web.Controls;
using BlogEngine.Core;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
#endregion

[Extension("Добавляет скрипты AnimatedCollapse к вашим виджетам", "1.0", "<a target=\"_blank\" href=\"http://www.dscoduc.com\">Chris Blankenship</a>")]
public class AnimatedCollapse
{
    private string extensionName = "AnimatedCollapse";

    public AnimatedCollapse()
    {
        BlogEngine.Core.Post.Serving += new EventHandler<ServingEventArgs>(ExecuteExtension);
        BlogEngine.Core.Page.Serving += new EventHandler<ServingEventArgs>(ExecuteExtension);
    }

    private void ExecuteExtension(object sender, ServingEventArgs e)
    {
        HttpContext context = HttpContext.Current;
        if (context.CurrentHandler is System.Web.UI.Page)
            if (context.Items[extensionName] == null)
            {
                // prep page handler
                System.Web.UI.Page page = (System.Web.UI.Page)context.CurrentHandler;

                // Add beginning comment line
                page.Header.Controls.Add(new System.Web.UI.LiteralControl(string.Format("{0}<!-- Begin {1} Extension v1.0 - www.dscoduc.com -->{0}", System.Environment.NewLine, extensionName)));

                // Add core JavaScript files to Head section
                page.Header.Controls.Add(JavaScriptInclude("js/jquery-pack.js"));
                page.Header.Controls.Add(new System.Web.UI.LiteralControl(System.Environment.NewLine));
                page.Header.Controls.Add(JavaScriptInclude("js/animatedcollapse.js"));

                // Add ending comment line
                page.Header.Controls.Add(new System.Web.UI.LiteralControl(string.Format("{0}<!-- End {1} Extension -->{0}", System.Environment.NewLine, extensionName)));

                // Add initialization script to bottom of page
                StringBuilder sbBottom = new StringBuilder();
                sbBottom.AppendLine("");
                sbBottom.AppendLine("<!-- Begin AnimatedCollapse Init -->");
                sbBottom.AppendLine("<script type=\"text/javascript\">animatedcollapse.init()</script>");
                sbBottom.AppendLine("<!-- End AnimatedCollapse Init -->");
                sbBottom.AppendLine("");
                page.ClientScript.RegisterStartupScript(page.GetType(), "AnimatedCollapseInit", sbBottom.ToString(), false);

                context.Items[extensionName] = 1;
            }
    }

    private HtmlGenericControl JavaScriptInclude(string url)
    {
        HtmlGenericControl script = new HtmlGenericControl("script");
        script.Attributes["type"] = "text/javascript";
        script.Attributes["src"] = ResolveScriptUrl(url);
        return script;
    }

    private string ResolveScriptUrl(string url)
    { return Utils.RelativeWebRoot + "js.axd?path=" + Utils.RelativeWebRoot + url; }

    private string ResolveCssUrl(string url)
    { return Utils.RelativeWebRoot + "css.axd?name=" + Utils.RelativeWebRoot + url; }
}
