#region using

using System;
using System.Web;
using BlogEngine.Core.Web.Controls;
using BlogEngine.Core;
using System.Net.Mail;
using System.Threading;
using System.Data;

#endregion

/// <summary>
/// Chris Blankenship
/// www.dscoduc.com
/// 
/// Description: Increases your readership and RSS subscription rate by simply sending a short 'thank you' relishing type message to users when they first comment on your weblog.
///  
/// Inspired by Justin Shattuck - http://www.justinshattuck.com/comment-relish/
/// 
/// </summary>
[Extension(" ,      ,    ", "1.0", "<a href=\"http://www.dscoduc.com\">DSCODUC</a>")]
public class CommentRelishHistory
{
    static protected ExtensionSettings _settings = null;

	public CommentRelishHistory()
	{
        ExtensionSettings settings = new ExtensionSettings("CommentRelishHistory");
        settings.AddParameter("EmailAddress", "Email Address", 200, true, true);
        settings.AddParameter("lastSentDate", "Last Sent Date", 50, false, false);
        settings.AddParameter("Website", "User Website", 100, false, false);
        settings.AddParameter("IPAddress", "User IP Address", 50, false, false);

        settings.AddValue("EmailAddress", "chris@dscoduc.com");
        settings.AddValue("lastSentDate", DateTime.Now.ToString("yyyy-MM-dd HH\\:mm")); //.AddHours(BlogSettings.Instance.Timezone).ToString("yyyy-MM-dd HH\\:mm"));
        settings.AddValue("Website", "http://www.dscoduc.com");
        settings.AddValue("IPAddress", "127.0.0.1");

        settings.Help = "This extension is used with CommentRelish and reflects who has been sent an email after posting a comment in your blog.";

        settings.IsScalar = false;
        ExtensionManager.ImportSettings(settings);
        _settings = ExtensionManager.GetSettings("CommentRelishHistory");

    }

}
