using System;
using BlogEngine.Core;
using BlogEngine.Core.Web.Controls;

/// <summary>
/// Adds a DotNetKicks button to a post where the token [kickit] is found, but this happens on the fly.
///
/// Now updated by Emir Trevio (www.emir.com.mx), because before not working with Windows Live Writer.
/// 
/// </summary>
[Extension("  DotNetKicks  ,   [kickit]", "1.0", @"<a href=""http://www.emir.com.mx/"">Emir Trevio</a>")]
public class DotNetKicksOntheFly
{
    public DotNetKicksOntheFly()
    {
        Post.Serving += new EventHandler<ServingEventArgs>(Post_Serving);
    }
    private void Post_Serving(object sender, ServingEventArgs e)
    {
        if (!e.Body.Contains("[kickit]"))
            return;

        if (e.Location == ServingLocation.PostList)
        {
            AddKickit(sender, e);
        }
        else if (e.Location == ServingLocation.SinglePost)
        {
            AddKickit(sender, e);
        }
        else if (e.Location == ServingLocation.Feed)
        {
            AddKickit(sender, e);
        }
    }

    private static void AddKickit(object sender, ServingEventArgs e)
    {
        Post post = (Post)sender;

        string imageBtn = String.Format(
                @"<a target=""_blank"" href=""http://www.dotnetkicks.com/kick/?url={0}&amp;title={1}"">
                    <img src=""http://www.dotnetkicks.com/Services/Images/KickItImageGenerator.ashx?url={0}"" border=""0"" alt=""kick it on DotNetKicks.com"" />
                  </a>", post.AbsoluteLink, post.Title);

        e.Body = e.Body.Replace("[kickit]", imageBtn);
    }


}