using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;

public partial class themes_MakeIT___Menu_controls_breadcrumb : System.Web.UI.UserControl
{
    /// <summary>
    /// The string that will be used as the separator of the breadcrumb nodes.  If no value is specified, ">" will be used.
    /// </summary>
    private const string defaultSeparator = " >> ";
    private string separator = defaultSeparator;
    public string Separator
    {
        get { return separator; }
        set { separator = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        
    }

    protected override void Render(HtmlTextWriter writer)
    {
        StringBuilder sb = new StringBuilder(100);
        SiteMapNode HomePage = SiteMap.RootNode;

        if (SiteMap.CurrentNode != null)
        {
            SiteMapNode current = SiteMap.CurrentNode;
            sb.Insert(0, string.Format("<a href=\"{0}\">{1}</a>{2}",current.Url, current.Title, separator));

           current = current.ParentNode;

            while (current != null)
            {
                sb.Insert(0, string.Format("<a href=\"{0}\">{1}</a>{2}", current.Url, current.Title, separator));
                current = current.ParentNode;
            }

            sb.Insert(0, string.Format("<a href=\"{0}\">{1}</a>{2}", BlogEngine.Core.Utils.RelativeWebRoot, HomePage.Title, separator));
        }

        writer.Write("<div class=\"breadCrumb\">" + ReplaceLast(sb.ToString(), separator, "") + "</div>");
        base.Render(writer);
    }

    /// <summary>
    /// Replaces the last occurence of a string with the replacement value.
    /// The replace is case senstive.
    /// </summary>
    /// <param name="input">The string to examine</param>
    /// <param name="oldValue">The value to replace</param>
    /// <param name="newValue">the new value to be inserted</param>
    /// <returns>A string</returns>
    public static string ReplaceLast(string input, string oldValue, string newValue)
    {
        int index = input.LastIndexOf(oldValue);
        if (index < 0)
        {
            return input;
        }
        else
        {
            StringBuilder sb = new StringBuilder(input.Length - oldValue.Length + newValue.Length);
            sb.Append(input.Substring(0, index));
            sb.Append(newValue);
            sb.Append(input.Substring(index + oldValue.Length,
               input.Length - index - oldValue.Length));

            return sb.ToString();
        }
    }
}
